using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace MapTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        IAsyncResult m_result;
        private AsyncCallback m_pfnCallBack;
        public Socket m_clientSocket;
        private class SocketPacket
        {
            public System.Net.Sockets.Socket thisSocket;
            public byte[] dataBuffer = new byte[2];
            public string strStackData = "";

            public SocketPacket(string StackData)
            {
                if (StackData != "")
                {
                    this.strStackData += StackData;
                }
                else
                {
                    this.strStackData = "";
                }
            }
        }
        private char charCR = (char)13;
        private Label lblMoreCarData = new Label();
        private eUp_UCMap.UCMap ucMap = new eUp_UCMap.UCMap();
        #region su禡

        private bool StartConnectServer(string strIP, string strPort)
        {
            bool blnConnectServer = true;
            // See if we have text on the IP and Port text fields
            //if (strIP == "" || strPort == "")
            //{
            //    MessageBox.Show("IP Address and Port Number are required to connect to the Server\n");
            //    return false;
            //}
            try
            {
                // Create the socket instance
                m_clientSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                // Cet the remote IP address
                IPAddress ip = IPAddress.Parse(strIP);
                int iPortNo = System.Convert.ToInt16(strPort);
                // Create the end point 
                IPEndPoint ipEnd = new IPEndPoint(ip, iPortNo);
                // Connect to the remote host
                m_clientSocket.Connect(ipEnd);
                if (m_clientSocket.Connected)
                {
                    //Wait for data asynchronously
                    WaitForData();
                    //this.WaitForUniData("");
                }
            }
            catch (SocketException se)
            {
                if (se.ErrorCode == 10065)
                {
                    //MessageBox.Show("LksuܺD,ˬd]w!", "tΰT");
                }
                //else
                //{
                //    MessageBox.Show(se.Message, "StartConnect");
                //}
                blnConnectServer = false;
            }
            return blnConnectServer;
        }

        private void WaitForData()
        {
            try
            {
                if (m_pfnCallBack == null)
                {
                    m_pfnCallBack = new AsyncCallback(OnDataReceived);
                }
                SocketPacket theSocPkt = new SocketPacket("");
                theSocPkt.thisSocket = m_clientSocket;
                // Start listening to the data asynchronously
                m_result = m_clientSocket.BeginReceive(theSocPkt.dataBuffer,
                                                        0, theSocPkt.dataBuffer.Length,
                                                        SocketFlags.None,
                                                        m_pfnCallBack,
                                                        theSocPkt);
            }
            catch (SocketException)// se)
            {
                //MessageBox.Show(se.Message);
            }
        }

        //Start waiting for data from the client
        private void WaitForData(string strGetData)
        {
            try
            {
                if (m_pfnCallBack == null)
                {
                    m_pfnCallBack = new AsyncCallback(OnDataReceived);
                }

                SocketPacket theSocPkt = new SocketPacket(strGetData);
                theSocPkt.thisSocket = m_clientSocket;
                // Start listening to the data asynchronously
                m_result = m_clientSocket.BeginReceive(theSocPkt.dataBuffer,
                                                        0, theSocPkt.dataBuffer.Length,
                                                        SocketFlags.None,
                                                        m_pfnCallBack,
                                                        theSocPkt);
            }
            catch (SocketException se)
            {
                if (se.ErrorCode == 10054)          // ݥD_u
                {
                //    if (MessageBox.Show("wȰPݥDsu,nssu?", "tΰT", MessageBoxButtons.OKCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.OK)
                //    {
                //        this.m_clientSocket.
                //    }
                //    else
                //    {
                //        this.m_clientSocket.Close();
                //    }
                }
                //MessageBox.Show(se.Message, "WaitForData:" + se.ErrorCode.ToString());
                //MessageBox.Show(se.Message, "WaitForData");
                //this.Close();
                //if (se.ErrorCode == 10054 || se.ErrorCode == 10065)
                //{
                //    this.ReConnectServer();
                //}
            }
        }

        private void OnDataReceived(IAsyncResult asyn)
        {
            int intEndCharIndex = 0;
            try
            {
                SocketPacket socketData = (SocketPacket)asyn.AsyncState;

                //int iRx = 0;
                // Complete the BeginReceive() asynchronous call by EndReceive() method
                // which will return the number of characters written to the stream 
                // by the client

                try
                {
                    //Encoding enc = Encoding.ASCII;
                    Encoding enc = Encoding.Unicode;
                    socketData.strStackData += enc.GetString(socketData.dataBuffer, 0, socketData.dataBuffer.Length);
                    intEndCharIndex = socketData.strStackData.IndexOf(this.charCR);
                    if (intEndCharIndex >= 0)
                    {
                        this.CmdCheck(socketData.strStackData.Substring(0, intEndCharIndex + 1));
                        socketData.strStackData = socketData.strStackData.Substring(intEndCharIndex + 1);
                    }
                }
                catch (Exception)// ex)
                {
                    //MessageBox.Show(ex.Message, "OnDataReceived");
                }

                // Continue the waiting for data on the Socket
                //				WaitForData( socketData.m_currentSocket );
                //if (socketData.m_currentSocket != null)
                //{
                WaitForData(socketData.strStackData);
                //}
                //}
            }
            catch (System.ObjectDisposedException)
            {
                //MessageBox.Show("Socket Object Disposed", "tδհT");
            }
            catch (Exception)// se)
            {
                //MessageBox.Show(se.Message);
            }
        }

        private void DisConnect()
        {
            //Socket s = (Socket)ar.AsyncState;
            //SocketPacket socketData = (SocketPacket)asyn.AsyncState;
            //s.EndConnect();

            try
            {
                if (m_clientSocket != null && m_clientSocket.Connected)
                {
                    //m_clientSocket.Shutdown(SocketShutdown.Both);
                    //System.Threading.Thread.Sleep(5000);
                    try
                    {
                        m_pfnCallBack = null;
                        //m_clientSocket.EndReceive(m_clientSocket.);
                        m_clientSocket.Close();
                        //System.Threading.Thread.Sleep(3000);
                    }
                    catch (Exception ex)
                    {
                        this.RecErrMessage(ex.Message, "", "Close Port");
                        //MessageBox.Show(ex.Message, "Close Port");
                    }
                    m_clientSocket = null;
                }
            }
            catch { }
        }

        //private void ReConnectServer()
        //{
        //    if (this.InvokeRequired)
        //    {
        //        this.BeginInvoke(new dglWaitForData(ReConnectServer));
        //        return;
        //    }
        //    if (!this.StartConnectServer(this.strServerIP, this.strConnectPort)) this.timerConnectServer.Enabled = true;
        //}
        #endregion

        /// <summary>
        /// ƤeϤ
        /// </summary>
        private void CmdCheck(string strData)
        {
            try
            {
                switch (strData[0])
                {
                    case 'M': 
                        this.lblMoreCarData.Text = strData.Substring(1);
                        break;
                    
                    default:
                        this.RecErrMessage(strData, "", "CmdCheck");
                        break;
                }
            }
            catch (Exception ex)
            {
                this.RecErrMessage(ex.Message, strData, "FormMain:CmdCheck");
            }
        }

        // tο~O
        public void RecErrMessage(string message, string MemoData, string ProcName)
        {
            try
            {
                FileInfo file = new FileInfo(Application.StartupPath + "\\ErrRecord.rec");     // w~Tsɮ

                StreamWriter writer = file.AppendText();

                writer.WriteLine(DateTime.Now.ToString());                                   // Oɶ(gJ{bɶ)
                //writer.WriteLine("FormName: " + FormName + " ; ProcName: " + ProcName);    // OoͿ~m
                writer.WriteLine("ProcName: " + ProcName + " ; MemoData: " + MemoData);      // OoͿ~m
                writer.WriteLine(message);                                                   // O~T
                writer.Close();
            }
            catch { }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (!this.StartConnectServer("127.0.0.1", "8080"))
            {
                MessageBox.Show("Not Connect Server.");
                Application.Exit();
            }
            this.textBox1.Text = @"D:\";
           
            CheckForIllegalCrossThreadCalls = false;
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ucMap.strADR = this.textBox1.Text;
            if (!ucMap.LoadMap())
            {
                MessageBox.Show("aϹϸ}ҥ!!\n\nˬdaϹϸɮ׬O_T!!\n\ntαN!!", "tξާ@");
                Application.Exit();
                return;
            }
       
            this.panel1.Visible = false;
            Form frmChild = new FormMoreCar(ref this.lblMoreCarData, ref this.m_clientSocket, ref this.ucMap);
            this.ShowChildForm(ref frmChild);
        }

        private void ShowChildForm(ref Form frmChild)
        {
            if (this.MdiChildren.Length > 0)
            {
                this.MdiChildren[0].Close();
            }

            frmChild.MdiParent = this;
            frmChild.Show();
            frmChild.Dock = DockStyle.Fill;
        }
    }
}